;*
;*    filename : npmrnc1.asm, release 1
;* description : decompression routine for Rob Northen's Packer, method 1
;*       coder : GuNHeD / NAPALM
;*        date : 04/2001
;*        note : napalm's routine based upon MIPS R4300 version 2.00
;*               by Icarus ( rnc_1.asm )
;*
;* some stats
;* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;*     testfile : pawlov.exe by elitegroup,
;*    orig size : 1.384.448 bytes
;*  packed size : 0.447.600 bytes ( PROPACK (tm) 2.19 )
;*   enviroment : SCPH-7002 running in PAL mode
;*
;*       source   binary size   speed
;* ~~~~~~~~~~~~   ~~~~~~~~~~~   ~~~~~~~~~~~~~~~~~~~~~~
;*    rnc_1.asm   1.496 bytes   02.6078 s = 0.506 mb/s
;*      dernc.c   ?.??? bytes   02.0101 s = 0.656 mb/s
;*  npmrnc1.asm   1.000 bytes   01.6158 s = 0.817 mb/s
;*
;* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;* all routines are slow anyway, but ours saves space and gives an
;* additional speedup ( still some room for optimization left )!
;* THIS SOURCE IS FOR LEGAL AND NONCOMMERCIAL PROJECTS ONLY!
;*

npm_rnc_decomp:
;  	( register use: a0 = source pointer, a1 = destination pointer )

	addi	sp,sp,-384
	move	s2,sp
	addi	sp,sp,-4
	sw	ra,0(sp)
	move	s0,a0
	move	s1,a1
	move	a3,a0
	addi	v1,zero,0xff
	sll	a0,v1,24
	sll	a1,v1,31
	srl	a3,a1,16
	nor	a2,zero,v1
	jal	func_410
	addi	s0,s0,4
	addi	s3,s0,10
	move	s4,s1
	move	t7,zero
	add	s5,s4,t0
	addi	t0,zero,2
	jal	func_3A0
	addi	t1,zero,2
text_180:
	jal	func_434
	move	s0,s2
	jal	func_434
	addi	s0,s2,128
	jal	func_434
	addi	s0,s2,256
	addi	t0,zero,-1
	jal	func_3A0
	addi	t1,zero,16
	move	t4,t0
	addi	t8,zero,-1
	srl	t8,t8,16
	addi	t4,t4,-1
	j	text_240
	and	t4,t8,t4
text_1E0:
	addi	s0,s2,128
	jal	func_2C8
	move	t0,zero
	subu	t0,zero,t0
	add	s1,s4,t0
	addi	s1,s1,-1
	jal	func_2C8
	addi	s0,s2,256
	addi	t8,t0,2
	slt	t0,s1,s4
	beqz	t0,ok
	subu	s0,s1,s4
	subu	s0,s4,s1
ok:
	slti	s0,s0,4
	bnez	s0,bcopy_1
checklen:
	sltiu	s0,t8,4
	bnez	s0,bcopy_1
	move	s0,t8
	addiu	s0,zero,4
wcopy:
	lwl	t0,3(s1)
	lwr	t0,0(s1)
	addu	s1,s1,s0
	swl	t0,3(s4)
	swr	t0,0(s4)
	subu	t8,t8,s0
	bnez	t8,checklen
	addu	s4,s4,s0
	j	text_240
bcopy_1:
	lbu	t0,0(s1)
	addi	s1,s1,1
	sb	t0,0(s4)
	addi	t8,t8,-1
	bnez	t8,bcopy_1
	addi	s4,s4,1
text_240:
	jal	func_2C8
	move	s0,s2
	addi	t0,t0,-1
	bltz	t0,text_2A8
	move	t8,t0
bcopy_2:
	lbu	t0,0(s3)
	addi	s3,s3,1
	sb	t0,0(s4)
	addi	s4,s4,1
	bnez	t8,bcopy_2
	addi	t8,t8,-1
	lwl	t0,3(s3)
	lwr	t0,0(s3)
	addi	t1,zero,1
	andi	t0,t0,0xffff
	sllv	t0,t0,t7
	sllv	t1,t1,t7
	addiu	t1,t1,-1
	and	t6,t6,t1
	or	t6,t0,t6
text_2A8:
	bnez	t4,text_1E0
	addi	t4,t4,-1
	sub	t8,s4,s5
	bltz	t8,text_180
	nop
	lw	ra,0(sp)
	addi	sp,sp,4
	jr	ra
	addi	sp,sp,384
;***	end	func_114

func_2C8:
	lw	t0,0(s0)
	nop
	srl	t8,t0,16
	andi	t0,t0,0xffff
	and	t0,t0,t6
	sub	t0,t0,t8
	bnez	t0,func_2C8
	addi	s0,s0,4
	lbu	t1,60(s0)
	move	s7,ra
	sub	t7,t7,t1
	bgez	t7,text_32C
	nop
	jal	func_3D4
	nop
text_32C:
	lbu	t0,61(s0)
	srlv	t6,t6,t1
	addi	t8,t0,-2
	bltz	t8,text_398
	nop
	addi	t0,t0,-1
	move	t1,t0
	move	t2,t0
	lbu	t8,62(s0)
	lbu	t0,63(s0)
	sll	t8,t8,8
	or	t0,t8,t0
	sub	t7,t7,t1
	bgez	t7,text_388
	and	t0,t0,t6
	jal	func_3D4
	nop
text_388:
	srlv	t6,t6,t1
	addi	t8,zero,1
	sllv	t8,t8,t2
	or	t0,t8,t0
text_398:
	move	ra,s7
	jr	ra
	nop
;***	end	func_2C8

func_3A0:
	addi	sp,sp,-4
	sw	ra,0(sp)
	sub	t7,t7,t1
	bgez	t7,text_3C8
	and	t0,t6,t0
	jal	func_3D4
	nop
text_3C8:
	lw	ra,0(sp)
	addi	sp,sp,4
	jr	ra
	srlv	t6,t6,t1
;***	end	func_3A0

func_3D4:
	add	t7,t7,t1
	lwl	t6,3(s3)
	lwr	t6,0(s3)
	addi	s3,s3,2
	sub	t1,t1,t7
	addi	t7,zero,16
	jr	ra
	sub	t7,t7,t1
;***	end	func_3D4

func_410:
	addi	t1,zero,3
text_414: ;=20
	sll	t0,t0,8
	lbu	t8,0(s0)
	addi	s0,s0,1
	or	t0,t8,t0
	bnez	t1,text_414
	addi	t1,t1,-1
	jr	ra
	nop
;***	end	func_410

func_434:
	addi	sp,sp,-4
	sw	ra,0(sp)
	addi	t0,zero,31
	jal	func_3A0
	addi	t1,zero,5
	addi	t0,t0,-1
	bltz	t0,text_5AC
	nop
	move	t2,t0
	move	t3,t0
	addi	sp,sp,-16
	move	s1,sp
text_470:
	addi	t0,zero,15
	jal	func_3A0
	addi	t1,zero,4
	sb	t0,0(s1)
	addi	s1,s1,1
	bnez	t2,text_470
	addi	t2,t2,-1
	move	t0,a1
	addi	t1,zero,1
	move	t2,zero
	addi	sp,sp,-16
	sw	t5,0(sp)
	sw	t6,4(sp)
	sw	t7,8(sp)
text_4BC:
	move	t4,t3
	addi	s1,sp,16
text_4C4:
	lbu	t8,0(s1)
	addi	s1,s1,1
	bne	t1,t8,text_580
	nop
	addi	t5,zero,1
	sllv	t5,t5,t1
	addi	t5,t5,-1
	sh	t5,0(s0)
	addi	s0,s0,2
	move	t5,t2
	sll	t8,t5,16
	srl	t5,t5,16
	or	t5,t5,t8
	move	t7,t1
	addi	t7,t7,-1
text_508:
	addi	t8,zero,-1
	srl	t8,t8,16
	and	t6,t8,t6
	and	t8,t5,a3
	sll	t5,t5,1
	beqz	t8,text_52C
	srl	t6,t6,1
	or	t6,t6,a3
text_52C:
	bnez	t7,text_508
	addi	t7,t7,-1
	addi	t5,zero,16
	sub	t5,t5,t1
	srlv	t6,t6,t5
	sh	t6,0(s0)
	addi	s0,s0,2
	sb	t1,60(s0)
	move	t5,t3
	subu	t5,t5,t4
	sb	t5,61(s0)
	addi	t6,zero,1
	addiu	t5,t5,-1
	sllv	t6,t6,t5
	addiu	t6,t6,-1
	sb	t6,63(s0)
	srl	t8,t6,8
	sb	t8,62(s0)
	addu	t2,t2,t0
text_580:
	bnez	t4,text_4C4
	addi	t4,t4,-1
	srl	t0,t0,1
	addi	t1,t1,1
	addi	t8,zero,17
	bne	t1,t8,text_4BC
	lw	t5,0(sp)
	lw	t6,4(sp)
	lw	t7,8(sp)
	addi	sp,sp,32
text_5AC:
	lw	ra,0(sp)
	addi	sp,sp,4
	jr	ra
	nop
;***	end	func_434
